/* 
    Zeta Dva, yet another amateur level chess engine
    Author: Srdja Matovic <srdja@matovic.de>
    Created at: 15-Jan-2011
    Updated at:
    Description: Amateur chesss programm

    Copyright (C) 2011 Srdja Matovic
    This program is distributed under the GNU General Public License.
    See file COPYING or http://www.gnu.org/licenses/

*/


#if !defined(TYPES_H_INCLUDED)
#define TYPES_H_INCLUDED


#  if defined(_MSC_VER)
typedef unsigned __int64 U64;
#  else
typedef unsigned long long int U64;
#endif

typedef signed short Score;
typedef unsigned int Square;
typedef unsigned int Piece;

typedef U64 Cr;
typedef U64 Boardindex;
typedef U64 Move;
typedef U64 Bitboard;
typedef U64 Hash;

#define WHITE 0
#define BLACK 1

#define true          1
#define false         0
#define bool int

#define KINGSIDE    0
#define QUEENSIDE   1

#define PVNODE      0
#define CUTNODE     1
#define ALLNODE     -1

#define PAWN    2
#define KNIGHT  3
#define BISHOP  4
#define ROOK    5
#define QUEEN   6
#define KING    7
#define PEMPTY  8

#define boardEmpty      8
#define boardCR         9
#define boardHash      10
#define boardScore     11

#define EXACTSCORE      0
#define FAILHIGH        1
#define FAILLOW        -1

#define MAX(a,b) ((a)>(b) ? (a) : (b))
#define MIN(a,b) ((a)<(b) ? (a) : (b))
#define FLIPFLOP(square)    (((square)^7)^56)
#define FLIP(square)     (((square)^7))
#define FLOP(square)    (((square))^56)

struct tt {
        U64 hash;
        Move bestmove;
        Score score;
        signed char flag;
        char depth;
        int ply;
        bool qs;
};

enum Square {
  SQ_A1, SQ_B1, SQ_C1, SQ_D1, SQ_E1, SQ_F1, SQ_G1, SQ_H1,
  SQ_A2, SQ_B2, SQ_C2, SQ_D2, SQ_E2, SQ_F2, SQ_G2, SQ_H2,
  SQ_A3, SQ_B3, SQ_C3, SQ_D3, SQ_E3, SQ_F3, SQ_G3, SQ_H3,
  SQ_A4, SQ_B4, SQ_C4, SQ_D4, SQ_E4, SQ_F4, SQ_G4, SQ_H4,
  SQ_A5, SQ_B5, SQ_C5, SQ_D5, SQ_E5, SQ_F5, SQ_G5, SQ_H5,
  SQ_A6, SQ_B6, SQ_C6, SQ_D6, SQ_E6, SQ_F6, SQ_G6, SQ_H6,
  SQ_A7, SQ_B7, SQ_C7, SQ_D7, SQ_E7, SQ_F7, SQ_G7, SQ_H7,
  SQ_A8, SQ_B8, SQ_C8, SQ_D8, SQ_E8, SQ_F8, SQ_G8, SQ_H8,
  SQ_NONE
};

#endif
